/******************************************************************************

Project:
    DirectNet ASYN

File:
    directNetClient.h

Description:
    Header describing client support routines for directNet over ASYN.

Author:
    Andrew Johnson
Version:
    $Id: directNetClient.h,v 1.1 2005/04/08 21:00:52 anj Exp $

******************************************************************************/

#ifndef INC_directNetClient_H
#define INC_directNetClient_H

#include <shareLib.h>

#ifdef __cplusplus
extern "C" {
#endif

extern const char *dn_error_strings[];

/* This structure hides the ASYN internals from the higher level code */
struct dnAsynClient;

struct plcMessage {
    const char *port;
    struct dnAsynClient *pClient;
    int cmd;
    int addr;
    int len; /* in bytes */
    char *pdata;
    int status;
    void (*callback)(struct plcMessage *pPvt);
    void (*connstat)(struct plcMessage *pPvt, int connected);
};

epicsShareFunc int epicsShareAPI initDnAsynClient(struct plcMessage* pPlcMsg);
epicsShareFunc int epicsShareAPI dnAsynClientSend(struct plcMessage *pPlcMsg);

#ifdef __cplusplus
}
#endif

#endif /* INC_directNetClient_H */
